From 89ae156eb5082f97d929c81d57936978f8b9e49e Mon Sep 17 00:00:00 2001
From: Rafia Sabih <rafia.sabih@cybertec.at>
Date: Wed, 26 Aug 2026 11:34:20 +0200
Subject: [PATCH v16 2/2] postgres_fdw: Add streaming_fetch option for
 cursor-free fetching

postgres_fdw uses cursors to fetch tuples from the remote server
incrementally. While this works correctly, cursors prevent the remote
side from using parallel query execution, which can significantly limit
performance for large scans.

This adds a new boolean option streaming_fetch, available at both the
server and table level, that gives an alternate fetching mechanism.
Because no cursor is created on the remote side, the remote query is free
to use parallel execution.

When a second scan begins on the same connection while another is still
in progress, the remaining tuples of the active scan are drained into a
tuplestore and replayed when execution returns to that scan. This
preserves correct results across nested or interleaved scans without
requiring an additional connection.

streaming_fetch defaults to false, preserving existing behavior.
Asynchronous execution is not supported in this mode and is disabled
automatically when streaming_fetch is enabled.

Original idea: Bernd Helmle
Key suggestions: Robert Haas
---
 contrib/postgres_fdw/connection.c             |   75 +-
 .../postgres_fdw/expected/postgres_fdw.out    | 1208 ++++++++++++++++-
 .../postgres_fdw/expected/query_cancel.out    |   23 +
 contrib/postgres_fdw/option.c                 |    4 +
 contrib/postgres_fdw/postgres_fdw.c           |  524 ++++++-
 contrib/postgres_fdw/postgres_fdw.h           |    8 +
 contrib/postgres_fdw/sql/postgres_fdw.sql     |  475 +++++++
 contrib/postgres_fdw/sql/query_cancel.sql     |   16 +
 doc/src/sgml/postgres-fdw.sgml                |   17 +
 9 files changed, 2242 insertions(+), 108 deletions(-)

diff --git a/contrib/postgres_fdw/connection.c b/contrib/postgres_fdw/connection.c
index b5d4cf3dccc..d705e69b7eb 100644
--- a/contrib/postgres_fdw/connection.c
+++ b/contrib/postgres_fdw/connection.c
@@ -163,11 +163,10 @@ static void pgfdw_inval_callback(Datum arg, SysCacheIdentifier cacheid,
 								 uint32 hashvalue);
 static void pgfdw_reject_incomplete_xact_state_change(ConnCacheEntry *entry);
 static void pgfdw_reset_xact_state(ConnCacheEntry *entry, bool toplevel);
-static bool pgfdw_cancel_query(PGconn *conn);
 static bool pgfdw_cancel_query_begin(PGconn *conn, TimestampTz endtime);
 static bool pgfdw_cancel_query_end(PGconn *conn, TimestampTz endtime,
 								   TimestampTz retrycanceltime,
-								   bool consume_input);
+								   bool consume_input, PgFdwConnState *state);
 static bool pgfdw_exec_cleanup_query(PGconn *conn, const char *query,
 									 bool ignore_errors);
 static bool pgfdw_exec_cleanup_query_begin(PGconn *conn, const char *query);
@@ -299,6 +298,13 @@ GetConnection(UserMapping *user, bool will_prep_stmt, PgFdwConnState **state)
 		/* Process a pending asynchronous request if any. */
 		if (entry->state.pendingAreq)
 			process_pending_request(entry->state.pendingAreq);
+
+		/*
+		 * If some other scan on this connection is using streaming_fetch and
+		 * still has an unconsumed result, drain it too, so the caller gets an
+		 * idle connection back.
+		 */
+		drain_other_active_scan(&entry->state);
 		/* Start a new transaction or subtransaction if needed. */
 		begin_remote_xact(entry);
 	}
@@ -1069,14 +1075,26 @@ GetPrepStmtNumber(PGconn *conn)
  * ignore that for now.
  *
  * Caller is responsible for the error handling on the result.
+ *
+ * Every caller must pass the PgFdwConnState for the connection (not NULL),
+ * so that if some other streaming_fetch scan on this connection still has
+ * an unconsumed result pending, we can drain it before sending a new query
+ * down the same connection.
  */
 PGresult *
 pgfdw_exec_query(PGconn *conn, const char *query, PgFdwConnState *state)
 {
 	/* First, process a pending asynchronous request, if any. */
-	if (state && state->pendingAreq)
+	if (state->pendingAreq)
 		process_pending_request(state->pendingAreq);
 
+	/*
+	 * If some other scan on this connection is using streaming_fetch and
+	 * still has an unconsumed result, drain it now so the connection is idle
+	 * before we send a new query.
+	 */
+	drain_other_active_scan(state);
+
 	if (!PQsendQuery(conn, query))
 		return NULL;
 	return pgfdw_get_result(conn);
@@ -1093,6 +1111,16 @@ pgfdw_get_result(PGconn *conn)
 	return libpqsrv_get_result_last(conn, pgfdw_we_get_result);
 }
 
+/*
+ * Used in case of streaming_fetch mode.
+ * Caller is responsible for the error handling on the result.
+ */
+PGresult *
+pgfdw_get_next_result(PGconn *conn)
+{
+	return libpqsrv_get_result(conn, pgfdw_we_get_result);
+}
+
 /*
  * Report an error we got from the remote server.
  *
@@ -1243,7 +1271,7 @@ pgfdw_xact_callback(XactEvent event, void *arg)
 					if (entry->have_prep_stmt && entry->have_error)
 					{
 						res = pgfdw_exec_query(entry->conn, "DEALLOCATE ALL",
-											   NULL);
+											   &entry->state);
 						PQclear(res);
 					}
 					entry->have_prep_stmt = false;
@@ -1569,9 +1597,10 @@ pgfdw_reset_xact_state(ConnCacheEntry *entry, bool toplevel)
  * XXX: if the query was one sent by fetch_more_data_begin(), we could get the
  * query text from the pendingAreq saved in the per-connection state, then
  * report the query using it.
+ * On success, also clears conn_state->active_scan via call to pgfdw_cancel_query_end.
  */
-static bool
-pgfdw_cancel_query(PGconn *conn)
+bool
+pgfdw_cancel_query(PGconn *conn, PgFdwConnState *state)
 {
 	TimestampTz now = GetCurrentTimestamp();
 	TimestampTz endtime;
@@ -1591,7 +1620,7 @@ pgfdw_cancel_query(PGconn *conn)
 
 	if (!pgfdw_cancel_query_begin(conn, endtime))
 		return false;
-	return pgfdw_cancel_query_end(conn, endtime, retrycanceltime, false);
+	return pgfdw_cancel_query_end(conn, endtime, retrycanceltime, false, state);
 }
 
 /*
@@ -1618,7 +1647,8 @@ pgfdw_cancel_query_begin(PGconn *conn, TimestampTz endtime)
 
 static bool
 pgfdw_cancel_query_end(PGconn *conn, TimestampTz endtime,
-					   TimestampTz retrycanceltime, bool consume_input)
+					   TimestampTz retrycanceltime, bool consume_input,
+					   PgFdwConnState *state)
 {
 	PGresult   *result;
 	bool		timed_out;
@@ -1654,6 +1684,8 @@ pgfdw_cancel_query_end(PGconn *conn, TimestampTz endtime,
 		return false;
 	}
 	PQclear(result);
+	/* Clear the active_scan */
+	state->active_scan = NULL;
 
 	return true;
 }
@@ -1906,7 +1938,7 @@ pgfdw_abort_cleanup(ConnCacheEntry *entry, bool toplevel)
 	 * remote server, and if so, request cancellation of the command.
 	 */
 	if (PQtransactionStatus(entry->conn) == PQTRANS_ACTIVE &&
-		!pgfdw_cancel_query(entry->conn))
+		!pgfdw_cancel_query(entry->conn, &entry->state))
 		return;					/* Unable to cancel running query */
 
 	CONSTRUCT_ABORT_COMMAND(sql, entry, toplevel);
@@ -1929,10 +1961,15 @@ pgfdw_abort_cleanup(ConnCacheEntry *entry, bool toplevel)
 	 * If pendingAreq of the per-connection state is not NULL, it means that
 	 * an asynchronous fetch begun by fetch_more_data_begin() was not done
 	 * successfully and thus the per-connection state was not reset in
-	 * fetch_more_data(); in that case reset the per-connection state here.
+	 * fetch_more_data().  Likewise, active_scan may still be pointing at a
+	 * streaming_fetch scan whose unconsumed result was never drained.  The
+	 * abort we just sent has already discarded any such state on the remote
+	 * side, and the (sub)transaction that owned that scan is going away, so
+	 * reset both unconditionally here rather than leave a dangling pointer
+	 * for the connection's next user.
 	 */
-	if (entry->state.pendingAreq)
-		memset(&entry->state, 0, sizeof(entry->state));
+	entry->state.pendingAreq = NULL;
+	entry->state.active_scan = NULL;
 
 	/* Disarm changing_xact_state if it all worked */
 	entry->changing_xact_state = false;
@@ -2151,7 +2188,7 @@ pgfdw_finish_abort_cleanup(List *pending_entries, List *cancel_requested,
 														  RETRY_CANCEL_TIMEOUT);
 
 			if (!pgfdw_cancel_query_end(entry->conn, endtime,
-										retrycanceltime, true))
+										retrycanceltime, true, &entry->state))
 			{
 				/* Unable to cancel running query */
 				pgfdw_reset_xact_state(entry, toplevel);
@@ -2221,9 +2258,9 @@ pgfdw_finish_abort_cleanup(List *pending_entries, List *cancel_requested,
 			entry->have_error = false;
 		}
 
-		/* Reset the per-connection state if needed */
-		if (entry->state.pendingAreq)
-			memset(&entry->state, 0, sizeof(entry->state));
+		/* Reset the async request and any undrained streaming_fetch scan */
+		entry->state.pendingAreq = NULL;
+		entry->state.active_scan = NULL;
 
 		/* We're done with this entry; unset the changing_xact_state flag */
 		entry->changing_xact_state = false;
@@ -2266,9 +2303,9 @@ pgfdw_finish_abort_cleanup(List *pending_entries, List *cancel_requested,
 		entry->have_prep_stmt = false;
 		entry->have_error = false;
 
-		/* Reset the per-connection state if needed */
-		if (entry->state.pendingAreq)
-			memset(&entry->state, 0, sizeof(entry->state));
+		/* Reset the async request and any undrained streaming_fetch scan */
+		entry->state.pendingAreq = NULL;
+		entry->state.active_scan = NULL;
 
 		/* We're done with this entry; unset the changing_xact_state flag */
 		entry->changing_xact_state = false;
diff --git a/contrib/postgres_fdw/option.c b/contrib/postgres_fdw/option.c
index 5b539c4eeef..14e5c5cd32f 100644
--- a/contrib/postgres_fdw/option.c
+++ b/contrib/postgres_fdw/option.c
@@ -122,6 +122,7 @@ postgres_fdw_validator(PG_FUNCTION_ARGS)
 			strcmp(def->defname, "parallel_abort") == 0 ||
 			strcmp(def->defname, "keep_connections") == 0 ||
 			strcmp(def->defname, "import_stats") == 0 ||
+			strcmp(def->defname, "streaming_fetch") == 0 ||
 			strcmp(def->defname, "use_scram_passthrough") == 0)
 		{
 			/* these accept only boolean values */
@@ -262,6 +263,9 @@ InitPgFdwOptions(void)
 		/* fetch_size is available on both server and table */
 		{"fetch_size", ForeignServerRelationId, false},
 		{"fetch_size", ForeignTableRelationId, false},
+		/* streaming_fetch is available on both server and table */
+		{"streaming_fetch", ForeignServerRelationId, false},
+		{"streaming_fetch", ForeignTableRelationId, false},
 		/* batch_size is available on both server and table */
 		{"batch_size", ForeignServerRelationId, false},
 		{"batch_size", ForeignTableRelationId, false},
